#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

public Plugin:myinfo = 
{
	name = "Equipments Editor",
	author = "R1KO",
	version = "1.1"
};

//new Handle:g_hAttachmentsArray;


new Handle:mp_forcecamera;

new Handle:g_hKeyValues;
new Handle:g_hEditMenu;
new bool:g_bIsCSGO;
new String:g_sPath[256];

new String:g_sCategory[MAXPLAYERS+1][64];
new String:g_sItem[MAXPLAYERS+1][64];
new String:g_sAttachment[MAXPLAYERS+1][64];
new g_iCatItem[MAXPLAYERS+1];
new g_iItem[MAXPLAYERS+1];

new Float:g_fOrigin[MAXPLAYERS+1][3];
new Float:g_fAngles[MAXPLAYERS+1][3];
new Float:g_fScale[MAXPLAYERS+1];

new bool:viendo[MAXPLAYERS+1];
new g_iEntity[MAXPLAYERS+1];

new MoveType:g_iClientMoveType[MAXPLAYERS+1];
new g_iEditMode[MAXPLAYERS+1];

new Float:g_fFrame;
new Float:g_fSteps[3];

new String:g_sModel[MAXPLAYERS+1][256];

#define POSITION		0
#define ANGLES		1
#define SCALE			2

public OnPluginStart()
{
//	g_hAttachmentsArray = CreateArray(ByteCountToCells(32));

	mp_forcecamera = FindConVar("mp_forcecamera");

	BuildPath(Path_SM, g_sPath, sizeof(g_sPath), "data/equipments.ini");

	HookEvent("player_death",	Event_RemoveEquip);
	HookEvent("player_team",	Event_RemoveEquip);

	HookEvent("player_spawn",	Event_PlayerSpawn);

	RegAdminCmd("equip_editor", Editor_CMD, ADMFLAG_ROOT);
	
	g_hEditMenu = CreateMenu(EditMenu_Handler, MenuAction_Display|MenuAction_DisplayItem|MENU_ACTIONS_DEFAULT);
	SetMenuTitle(g_hEditMenu, "Редактор:\n ");
	SetMenuExitBackButton(g_hEditMenu, true);
	
	AddMenuItem(g_hEditMenu, "", "Позиция");

	AddMenuItem(g_hEditMenu, "", "Вращение");

	AddMenuItem(g_hEditMenu, "", "Размер");

	AddMenuItem(g_hEditMenu, "", "Сохранить");
/*
	g_hPositionMenu = CreateMenu(PositionMenu_Handler, MenuAction_Display|MenuAction_DisplayItem|MENU_ACTIONS_DEFAULT);
	SetMenuTitle(g_hPositionMenu, "Позиция:\n ");
	SetMenuExitBackButton(g_hPositionMenu, true);

	AddMenuItem(g_hPositionMenu, "+X", "X +");
	AddMenuItem(g_hPositionMenu, "-X", "X -");
	AddMenuItem(g_hPositionMenu, "+Y", "Y +");
	AddMenuItem(g_hPositionMenu, "-Y", "Y -");
	AddMenuItem(g_hPositionMenu, "+Z", "Z +");
	AddMenuItem(g_hPositionMenu, "-Z", "Z -");

	g_hAnglesMenu = CreateMenu(AnglesMenu_Handler, MenuAction_Display|MenuAction_DisplayItem|MENU_ACTIONS_DEFAULT);
	SetMenuTitle(g_hAnglesMenu, "Вращение:\n ");
	SetMenuExitBackButton(g_hAnglesMenu, true);

	AddMenuItem(g_hAnglesMenu, "+X", "X +");
	AddMenuItem(g_hAnglesMenu, "-X", "X -");
	AddMenuItem(g_hAnglesMenu, "+Y", "Y +");
	AddMenuItem(g_hAnglesMenu, "-Y", "Y -");
	AddMenuItem(g_hAnglesMenu, "+Z", "Z +");
	AddMenuItem(g_hAnglesMenu, "-Z", "Z -");

	g_hSizeMenu = CreateMenu(SizeMenu_Handler, MenuAction_Display|MenuAction_DisplayItem|MENU_ACTIONS_DEFAULT);
	SetMenuTitle(g_hSizeMenu, "Размер:\n ");
	SetMenuExitBackButton(g_hSizeMenu, true);

	AddMenuItem(g_hSizeMenu, "s+", "Размер + 0.05");
	AddMenuItem(g_hSizeMenu, "s-", "Размер - 0.05");
*/
}

public Action:Editor_CMD(iClient, iArgs)
{
	if(iClient)
	{
		DisplayCategoriesMenu(iClient);
	}

	return Plugin_Handled;
}

public OnMapStart()
{
//	ClearArray(g_hAttachmentsArray);

	if(g_hKeyValues != INVALID_HANDLE)
	{
		CloseHandle(g_hKeyValues);
	}

	g_hKeyValues = CreateKeyValues("EquipmentsEditor");

	decl String:sBuffer[256];
	BuildPath(Path_SM, sBuffer, sizeof(sBuffer), "data/equipments_editor.ini");
	if (FileToKeyValues(g_hKeyValues, sBuffer) == false)
	{
		CloseHandle(g_hKeyValues);
		SetFailState("Couldn't parse file '%s'", sBuffer);
		return;
	}

	KvRewind(g_hKeyValues);

	g_bIsCSGO = (GetEngineVersion() == Engine_CSGO);
	
	g_fFrame = KvGetFloat(g_hKeyValues, "Frame", 0.25);
	
	/*
	if(KvJumpToKey(g_hKeyValues, "Attachments"))
	{
		if(KvGotoFirstSubKey(g_hKeyValues, false))
		{
			do
			{
				KvGetString(g_hKeyValues, NULL_STRING, sBuffer, 32);
				PushArrayString(g_hAttachmentsArray, sBuffer);
			} while(KvGotoNextKey(g_hKeyValues, false));
		}
	}
	*/

	KvRewind(g_hKeyValues);
	
	if(KvJumpToKey(g_hKeyValues, "Steps"))
	{
		g_fSteps[POSITION] = KvGetFloat(g_hKeyValues, "Position", 5.0);
		g_fSteps[ANGLES] = KvGetFloat(g_hKeyValues, "Angles", 5.0);
		g_fSteps[SCALE] = KvGetFloat(g_hKeyValues, "Scale", 0.05);
	}

	CloseHandle(g_hKeyValues);

	g_hKeyValues = CreateKeyValues("Equipments");

	if (FileToKeyValues(g_hKeyValues, g_sPath) == false)
	{
		CloseHandle(g_hKeyValues);
		SetFailState("Couldn't parse file '%s'", g_sPath);
		return;
	}

	KvRewind(g_hKeyValues);

	if(KvGotoFirstSubKey(g_hKeyValues))
	{
		do
		{
			if(KvGotoFirstSubKey(g_hKeyValues))
			{
				do
				{
					KvGetString(g_hKeyValues, "model", sBuffer, sizeof(sBuffer));
					if(sBuffer[0] && (FileExists(sBuffer) || FileExists(sBuffer, true)))
					{
						PrecacheModel(sBuffer, true);
					}
				} while(KvGotoNextKey(g_hKeyValues));

				KvGoBack(g_hKeyValues);
			}
		} while(KvGotoNextKey(g_hKeyValues));
	}
}

public Action:OnPlayerRunCmd(iClient, &iButtons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if(IsPlayerAlive(iClient) && g_iEntity[iClient] > 0 && g_iEditMode[iClient] != -1)
	{
		static Float:fNextPrint, Float:fNextUse, Float:fTime;
		
		fTime = GetGameTime();
		if(fTime > fNextPrint)
		{
			switch(g_iEditMode[iClient])
			{
				case POSITION:	PrintHintText(iClient, "W - вперед\n\
																S - назад\n\
																A - ввлево\n\
																D - вправо\n\
																Shift - вверх\n\
																Space - вниз");
				case ANGLES:		PrintHintText(iClient, "W - вперед\n\
																S - назад\n\
																A - ввлево\n\
																D - вправо\n\
																Shift - Против часовой\n\
																Space - По часовой");
				case SCALE:		PrintHintText(iClient, "Shift - Больше\n\
																Space - Меньше");
			}
			
			fNextPrint = fTime+3.0;
		}
	
		if(fTime < fNextUse)
		{
			return Plugin_Continue;
		}

		fNextUse = fTime+g_fFrame;

		switch(g_iEditMode[iClient])
		{
			case POSITION:
			{
				if (iButtons & IN_FORWARD)
				{
					// X +
					g_fOrigin[iClient][0] += g_fSteps[POSITION];
				}
				if (iButtons & IN_BACK)
				{
					// X -
					g_fOrigin[iClient][0] -= g_fSteps[POSITION];
				}
				if(iButtons & IN_MOVELEFT)
				{
					// Y +
					g_fOrigin[iClient][1] += g_fSteps[POSITION];
				}
				if(iButtons & IN_MOVERIGHT)
				{
					// Y -
					g_fOrigin[iClient][1] -= g_fSteps[POSITION];
				}
				if(iButtons & IN_SPEED)
				{
					// Z +
					g_fOrigin[iClient][2] += g_fSteps[POSITION];
				}
				if(iButtons & IN_JUMP)
				{
					// Z -
					g_fOrigin[iClient][2] -= g_fSteps[POSITION];
				}
				TeleportEntity(g_iEntity[iClient], g_fOrigin[iClient], NULL_VECTOR, NULL_VECTOR);
			}
			case ANGLES:
			{
				if (iButtons & IN_FORWARD)
				{
					// X +
					g_fAngles[iClient][0] += g_fSteps[ANGLES];
				}
				if (iButtons & IN_BACK)
				{
					// X -
					g_fAngles[iClient][0] -= g_fSteps[ANGLES];
				}
				if(iButtons & IN_MOVELEFT)
				{
					// Z +
					g_fAngles[iClient][2] += g_fSteps[ANGLES];
				}
				if(iButtons & IN_MOVERIGHT)
				{
					// Z -
					g_fAngles[iClient][2] -= g_fSteps[ANGLES];
				}
				if(iButtons & IN_SPEED)
				{
					// Y +
					g_fAngles[iClient][1] += g_fSteps[ANGLES];
				}
				if(iButtons & IN_JUMP)
				{
					// Y -
					g_fAngles[iClient][1] -= g_fSteps[ANGLES];
				}
				TeleportEntity(g_iEntity[iClient], NULL_VECTOR, g_fAngles[iClient], NULL_VECTOR);
			}
			case SCALE:
			{
				if(iButtons & IN_SPEED)
				{
					g_fScale[iClient] += g_fSteps[ANGLES];
				}
				else if(iButtons & IN_JUMP)
				{
					g_fScale[iClient] -= g_fSteps[ANGLES];
				}
				new iScaleOfsset = GetEntSendPropOffs(g_iEntity[iClient], "m_flModelScale", true);
				if(iScaleOfsset != -1)
				{
					SetEntDataFloat(g_iEntity[iClient], iScaleOfsset, g_fScale[iClient], true);
				}
			}
		}
	}
	return Plugin_Continue;
}

View(iClient, bool:bEnable)
{
	viendo[iClient] = bEnable;
	SetThirdPersonView(iClient, bEnable);

	if(bEnable)
	{
		g_iClientMoveType[iClient] = GetEntityMoveType(iClient);
		SetEntityMoveType(iClient, MOVETYPE_NONE);
	}
	else
	{
		SetEntityMoveType(iClient, GetEntityMoveType(iClient));
	}
}

KvGetEquitData(iClient)
{
	KvGetString(g_hKeyValues, "attachment", g_sAttachment[iClient], sizeof(g_sAttachment[]), "facemask");

	KvGetVector(g_hKeyValues, "position", g_fOrigin[iClient]);
	KvGetVector(g_hKeyValues, "angles", g_fAngles[iClient]);

	g_fScale[iClient] = KvGetFloat(g_hKeyValues, "scale", 1.0);
}

#define HIDE_CROSSHAIR_CSGO 1<<8
#define HIDE_RADAR_CSGO 1<<12

SetThirdPersonView(iClient, bool:third)
{
	if (!IsPlayerAlive(iClient))
	{
		return;
	}
	
	if(third)
	{
		
		SetEntPropEnt(iClient, Prop_Send, "m_hObserverTarget", 0); 
		SetEntProp(iClient, Prop_Send, "m_iObserverMode", 1);
		SetEntProp(iClient, Prop_Send, "m_bDrawViewmodel", 0);
		SetEntProp(iClient, Prop_Send, "m_iFOV", 120);
		SendConVarValue(iClient, mp_forcecamera, "1");
		//SetEntPropFloat(iClient, Prop_Data, "m_flLaggedMovementValue", 0.0);
		
		if(g_bIsCSGO)
		{
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") | HIDE_RADAR_CSGO);
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") | HIDE_CROSSHAIR_CSGO);
		}
	}
	else
	{
		SetEntPropEnt(iClient, Prop_Send, "m_hObserverTarget", -1);
		SetEntProp(iClient, Prop_Send, "m_iObserverMode", 0);
		SetEntProp(iClient, Prop_Send, "m_bDrawViewmodel", 1);
		SetEntProp(iClient, Prop_Send, "m_iFOV", 90);
		decl String:valor[6];
		GetConVarString(mp_forcecamera, valor, 6);
		SendConVarValue(iClient, mp_forcecamera, valor);
		//SetEntPropFloat(iClient, Prop_Data, "m_flLaggedMovementValue", 1.0);
		
		if(g_bIsCSGO)
		{
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") & ~HIDE_RADAR_CSGO);
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") & ~HIDE_CROSSHAIR_CSGO);
		}
	}
}  

SaveCfg(iClient)
{
	KvRewind(g_hKeyValues);
	if(KvJumpToKey(g_hKeyValues, g_sCategory[iClient]))
	{
		if(KvJumpToKey(g_hKeyValues, g_sItem[iClient]))
		{
			if(g_sModel[iClient][0])
			{
				KvJumpToKey(g_hKeyValues, g_sModel[iClient], true);
			}

			KvSetString(g_hKeyValues, "attachment", g_sAttachment[iClient]);
			KvSetVector(g_hKeyValues, "position", g_fOrigin[iClient]);
			KvSetVector(g_hKeyValues, "angles", g_fAngles[iClient]);
			KvSetFloat(g_hKeyValues, "scale", g_fScale[iClient]);
		}
	}
	
	KvRewind(g_hKeyValues);
	KeyValuesToFile(g_hKeyValues, g_sPath);
	PrintToChat(iClient, "Конфиг сохранен!");
}

public Event_RemoveEquip(Handle:hEvent, const String:sEvName[], bool:dBontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "userid"));

	View(iClient, false);
	RemoveEquipClient(iClient);
}

public Event_PlayerSpawn(Handle:hEvent, const String:sEvName[], bool:dBontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "userid"));

	if(iClient && IsPlayerAlive(iClient) && GetClientTeam(iClient) > 1 && g_sCategory[iClient][0] && g_sItem[iClient][0])
	{
		EquipClient(iClient);
		if(viendo[iClient])
		{
			SetThirdPersonView(iClient, true);
		}
	}
}

RemoveEquipClient(iClient)
{
	if(g_iEntity[iClient] > 0)
	{
		if(IsValidEntity(g_iEntity[iClient]))
		{
			AcceptEntityInput(g_iEntity[iClient], "Kill");
		}

		g_iEntity[iClient] = -1;
	}
}

EquipClient(iClient)
{
	KvRewind(g_hKeyValues);
	if(KvJumpToKey(g_hKeyValues, g_sCategory[iClient]))
	{
		if(KvJumpToKey(g_hKeyValues, g_sItem[iClient]))
		{
			g_iEntity[iClient] = CreateItem(iClient);
		}
	}
}

CreateItem(iClient)
{
	LogMessage("CreateItem");

	new Float:fItemOrigin[3], Float:fItemAngles[3], Float:fForward[3], Float:fRight[3], Float:fUp[3];
	
	LogMessage("Temp Pos: %.3f %.3f %.3f, Ang: %.3f %.3f %.3f", g_fOrigin[iClient][0], g_fOrigin[iClient][1], g_fOrigin[iClient][2], g_fAngles[iClient][0], g_fAngles[iClient][1], g_fAngles[iClient][2]);

	GetClientAbsOrigin(iClient, fItemOrigin);
	GetClientAbsAngles(iClient, fItemAngles);
	
	LogMessage("Client Pos: %.3f %.3f %.3f, Ang: %.3f %.3f %.3f", fItemOrigin[0], fItemOrigin[1], fItemOrigin[2], fItemAngles[0], fItemAngles[1], fItemAngles[2]);

	fItemAngles[0] += g_fAngles[iClient][0];
	fItemAngles[1] += g_fAngles[iClient][1];
	fItemAngles[2] += g_fAngles[iClient][2];
	
	LogMessage("Offset Ang: %.3f %.3f %.3f", fItemAngles[0], fItemAngles[1], fItemAngles[2]);

	GetAngleVectors(fItemAngles, fForward, fRight, fUp);
	
	LogMessage("GetAngleVectors Pos: %.3f %.3f %.3f", fItemOrigin[0], fItemOrigin[1], fItemOrigin[2]);

	fItemOrigin[0] += fRight[0]*g_fOrigin[iClient][0] + fForward[0]*g_fOrigin[iClient][1] + fUp[0]*g_fOrigin[iClient][2];
	fItemOrigin[1] += fRight[1]*g_fOrigin[iClient][0] + fForward[1]*g_fOrigin[iClient][1] + fUp[1]*g_fOrigin[iClient][2];
	fItemOrigin[2] += fRight[2]*g_fOrigin[iClient][0] + fForward[2]*g_fOrigin[iClient][1] + fUp[2]*g_fOrigin[iClient][2];
	
	LogMessage("Offset Origin: %.3f %.3f %.3f", fItemOrigin[0], fItemOrigin[1], fItemOrigin[2]);

	new iEntity = CreateEntityByName("prop_dynamic_override");

	decl String:sModel[256];
	KvGetString(g_hKeyValues, "model", sModel, sizeof(sModel));
	DispatchKeyValue(iEntity, "model", sModel);
	DispatchKeyValue(iEntity, "spawnflags", "256");
	DispatchKeyValue(iEntity, "solid", "0");
	SetEntPropEnt(iEntity, Prop_Send, "m_hOwnerEntity", iClient);
	
	if(KvGetNum(g_hKeyValues, "bonemerge"))
	{
		new iEntEffects = GetEntProp(iEntity, Prop_Send, "m_fEffects"); 
		iEntEffects &= ~32;
		iEntEffects |= 1;
		iEntEffects |= 128;
		SetEntProp(iEntity, Prop_Send, "m_fEffects", iEntEffects); 
	}

	DispatchSpawn(iEntity);	

	new iScaleOfsset = GetEntSendPropOffs(iEntity, "m_flModelScale", true);
	if(iScaleOfsset != -1)
	{
		SetEntDataFloat(iEntity, iScaleOfsset, g_fScale[iClient], true);
	}

	AcceptEntityInput(iEntity, "TurnOn", iEntity, iEntity, 0);

	LogMessage("Final Pos: %.3f %.3f %.3f, Ang: %.3f %.3f %.3f", fItemOrigin[0], fItemOrigin[1], fItemOrigin[2], fItemAngles[0], fItemAngles[1], fItemAngles[2]);
	TeleportEntity(iEntity, fItemOrigin, fItemAngles, NULL_VECTOR); 

	SetVariantString("!activator");
	AcceptEntityInput(iEntity, "SetParent", iClient, iEntity, 0);

	SetVariantString(g_sAttachment[iClient]);
	AcceptEntityInput(iEntity, "SetParentAttachmentMaintainOffset", iEntity, iEntity, 0);	

	return iEntity;
}


// Выбор категории
DisplayCategoriesMenu(iClient, Item = 0)
{
	decl Handle:hMenu, String:sClientLang[3], String:sServerLang[3];
	hMenu = CreateMenu(CategoriesMenu_Handler);
	SetMenuExitBackButton(hMenu, false);
	SetMenuTitle(hMenu, "Экипировка:\n ");

	GetLanguageInfo(GetClientLanguage(iClient), sClientLang, sizeof(sClientLang));
	GetLanguageInfo(GetServerLanguage(), sServerLang, sizeof(sServerLang));

	KvRewind(g_hKeyValues);

	if(KvGotoFirstSubKey(g_hKeyValues))
	{
		decl String:sItemInfo[64], String:sDisplay[128];

		do
		{
			KvGetSectionName(g_hKeyValues, sItemInfo, sizeof(sItemInfo));
			KvGetString(g_hKeyValues, sClientLang, sDisplay, sizeof(sDisplay));
			if (!sDisplay[0])
			{
				KvGetString(g_hKeyValues, sServerLang, sDisplay, sizeof(sDisplay));
				if (!sDisplay[0])
				{
					strcopy(sDisplay, sizeof(sDisplay), sItemInfo);
				}
			}

			AddMenuItem(hMenu, sItemInfo, sDisplay);

		} while(KvGotoNextKey(g_hKeyValues));
	}

	DisplayMenuAtItem(hMenu, iClient, Item, MENU_TIME_FOREVER);
}

// Выбрали категорию
public CategoriesMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_End: CloseHandle(hMenu);
		case MenuAction_Select:
		{
			GetMenuItem(hMenu, Item, g_sCategory[iClient], sizeof(g_sCategory[]));
			g_iCatItem[iClient] = Item;

			DisplayItemsMenu(iClient);
		}
	}
}

// Выбор предмета
DisplayItemsMenu(iClient, Item = 0)
{
	decl Handle:hMenu, String:sBuffer[128], String:sClientLang[3], String:sServerLang[3], String:sItemInfo[64], String:sDisplay[128];
	hMenu = CreateMenu(ItemsMenu_Handler);
	SetMenuExitBackButton(hMenu, true);

	KvRewind(g_hKeyValues);
	if(KvJumpToKey(g_hKeyValues, g_sCategory[iClient]))
	{
		GetLanguageInfo(GetClientLanguage(iClient), sClientLang, sizeof(sClientLang));
		GetLanguageInfo(GetServerLanguage(), sServerLang, sizeof(sServerLang));
		
		KvGetSectionName(g_hKeyValues, sItemInfo, sizeof(sItemInfo));
		KvGetString(g_hKeyValues, sClientLang, sDisplay, sizeof(sDisplay));
		if (!sDisplay[0])
		{
			KvGetString(g_hKeyValues, sServerLang, sDisplay, sizeof(sDisplay));
			if (!sDisplay[0])
			{
				strcopy(sDisplay, sizeof(sDisplay), sItemInfo);
			}
		}

		SetMenuTitle(hMenu, "%s:\n ", sDisplay);

		if(KvGotoFirstSubKey(g_hKeyValues))
		{
			do
			{
				KvGetString(g_hKeyValues, "name", sDisplay, sizeof(sDisplay));
				KvGetSectionName(g_hKeyValues, sBuffer, sizeof(sBuffer));
				if(!sDisplay[0])
				{
					strcopy(sDisplay, sizeof(sDisplay), sBuffer);
				}

				AddMenuItem(hMenu, sBuffer, sDisplay);
			} while(KvGotoNextKey(g_hKeyValues));
		}
	}

	if(GetMenuItemCount(hMenu) == 0)
	{
		AddMenuItem(hMenu, "", "Нет предметов", ITEMDRAW_DISABLED);
	}

	DisplayMenuAtItem(hMenu, iClient, Item, MENU_TIME_FOREVER);
}

// Выбрали предмет
public ItemsMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_End: CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) DisplayCategoriesMenu(iClient, g_iCatItem[iClient]);
		}
		case MenuAction_Select:
		{
			GetMenuItem(hMenu, Item, g_sItem[iClient], sizeof(g_sItem[]));
			g_iItem[iClient] = Item;
			
			DisplayEquipMenu(iClient);
		}
	}
}

DisplayEquipMenu(iClient)
{
	new Handle:hMenu = CreateMenu(EquipMenu_Handler);
	SetMenuExitBackButton(hMenu, false);
	SetMenuTitle(hMenu, "%s->%s:\n ", g_sCategory[iClient], g_sItem[iClient]);

	AddMenuItem(hMenu, "edit", "Изменить");
	AddMenuItem(hMenu, "edit_f_skin", "Изменить для текущего скина");

	DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
}


public EquipMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_End: CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) DisplayItemsMenu(iClient);
		}
		case MenuAction_Select:
		{
			switch(Item)
			{
				case 0:
				{
					KvRewind(g_hKeyValues);
					if(KvJumpToKey(g_hKeyValues, g_sCategory[iClient]))
					{
						if(KvJumpToKey(g_hKeyValues, g_sItem[iClient]))
						{
							KvGetEquitData(iClient);
							g_sModel[iClient][0] = 0;
							DisplayMenu(g_hEditMenu, iClient, MENU_TIME_FOREVER);
						}
					}
				}
				case 1:
				{
					KvRewind(g_hKeyValues);
					if(KvJumpToKey(g_hKeyValues, g_sCategory[iClient]))
					{
						if(KvJumpToKey(g_hKeyValues, g_sItem[iClient]))
						{
							GetClientModel(iClient, g_sModel[iClient], sizeof(g_sModel[]));
							ReplaceString(g_sModel[iClient], sizeof(g_sModel[]), "/", "\\");
							Format(g_sModel[iClient], sizeof(g_sModel[]), "playermodels/%s", g_sModel[iClient]);
							KvJumpToKey(g_hKeyValues, g_sModel[iClient]);
							KvGetEquitData(iClient);
						}
					}
				}
				case 2:
				{
					SaveCfg(iClient);
					DisplayEquipMenu(iClient);
				}
			}
		}
	}
}

public EditMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) DisplayItemsMenu(iClient);

			if(IsClientInGame(iClient) && viendo[iClient])
			{
				View(iClient, false);
			}

			g_iEditMode[iClient] = -1;
		}
		case MenuAction_Display:
		{
			View(iClient, true);
		//	g_iEditMode[iClient] = 0;
			RemoveEquipClient(iClient);
			EquipClient(iClient);
		}
		case MenuAction_DisplayItem:
		{
			if(g_iEditMode[iClient] == Item)
			{
				decl String:sBuffer[128];
				GetMenuItem(hMenu, Item, "", 0, _, sBuffer, sizeof(sBuffer));
				Format(sBuffer, sizeof(sBuffer), "%s [x]", sBuffer);
				return RedrawMenuItem(sBuffer);
			}
		}
		case MenuAction_Select:
		{
			if(Item == 3)
			{
				SaveCfg(iClient);
			}
			else
			{
				g_iEditMode[iClient] = Item;
			}

			DisplayMenuAtItem(g_hEditMenu, iClient, GetMenuSelectionPosition(), MENU_TIME_FOREVER);
		}
	}

	return 0;
}